<?php

# Version: 1.2 -- http://www.archaicbinary.net -- Torrent Trader

$torrentspath = '/var/www/domain.com/httpdocs/torrents/'; // Path to Torrent Storage Folder, Example: /var/www/vhosts/domain.com/httpdocs/torrents/

$dbhost = "localhost"; // Hostname of MySQL Server
$dbuser = "username here"; // Database Username
$dbpassword = "password here"; // Database Password Joomla Uses
$databasename = "joomla database name here"; // Your Main Joomla Database Name
$dbtorrentstable = "jos_torrenttrader_torrents"; // Change if Necessary

require("components/com_torrenttrader/BDecode.php"); // Path to BDecode.php, Example: /var/www/vhosts/domain.com/httpdocs/components/com_torrenttrader/BDecode.php
require("components/com_torrenttrader/BEncode.php"); // Path to BEncode.php, Example: /var/www/vhosts/domain.com/httpdocs/components/com_torrenttrader/BEncode.php

# ----------------------- Change Nothing Below ---------------------------------------------#

# Version 1.1

$database = mysql_connect($dbhost, $dbuser, $dbpassword)
	  or die ("Unable to Connect");

mysql_select_db ($databasename, $database)
	  or die ("Unable to Select Database");

	function getfilesize($bytes) {
		if ($bytes >= 1099511627776){
			$return = round($bytes / 1024 / 1024 / 1024 / 1024, 2);
			$suffix = "TB";
		}elseif ($bytes >= 1073741824){
			$return = round($bytes / 1024 / 1024 / 1024, 2);
			$suffix = "GB";
		}elseif ($bytes >= 1048576){
			$return = round($bytes / 1024 / 1024, 2);
			$suffix = "MB";
		}elseif ($bytes >= 1024){
			$return = round($bytes / 1024, 2);
			$suffix = "KB";
		}else{
			$return = $bytes;
			$suffix = "Byte";
		}

		if ($return == 1){
			$return .= " " . $suffix;
		}else{
			$return .= " " . $suffix . "s";
		}

		return $return;
	}

	function pathurlencode($uri) {
		$uri = urlencode($uri);
		$uri = str_replace('%3A', ':', $uri);
		$uri = str_replace('%2F', '/', $uri);
		$uri = str_replace('%26', '&', $uri);
		$uri = str_replace('%40', '@', $uri);
		$uri = str_replace('%3A', ':', $uri);
		$uri = str_replace('%3F', '?', $uri);
		$uri = str_replace('%3D', '=', $uri);
		$uri = str_replace('%5B', '[', $uri);
		$uri = str_replace('%5D', ']', $uri);
		return $uri;
	}

function sapeerconnect($httpurl, $binsha1s, $torrentsize){
	global $seeds, $peers, $completeddl, $estbandwidth, $error;

	$error = "";

	set_time_limit(0);

	$ch = curl_init();
	$timeout = 15;
	$curlconnection = curl_setopt ($ch, CURLOPT_URL, $httpurl);

	$stream = "";

	if ($curlconnection) {
			curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
			curl_setopt ($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
			$stream = curl_exec($ch);
	}

	curl_close($ch);

	if(!$curlconnection){
		$error = "No Response From Tracker. Please Try Again." ;
	}else{
		$decoded = BDecode($stream);
		if ($decoded["files"] === TRUE){
			$error = "File not present on tracker (torrent may be dead).";
		}else{
			$sha1files = $decoded["files"];
			$sha1tor = $sha1files[$binsha1s];
			if(isset($sha1files[$binsha1s])){
				$seeds = $sha1tor['complete'];
				$peers = $sha1tor['incomplete'];
				if(isset($sha1tor['downloaded'])){
					$completeddl = $sha1tor['downloaded'];
					if(isset($torrentsize)){
						$bandwidth = $sha1tor['downloaded'] * $torrentsize;
						$estbandwidth = getfilesize($bandwidth);
					}
				}
			}else{
				$error = "Error with Tracker Response.";
			}
		}
	}
}

$query = mysql_query("SELECT filename FROM $dbtorrentstable ORDER BY RAND() LIMIT 10")
	or die ("Unable to Run Query");

while ($row = mysql_fetch_assoc($query)){

	$torrentfilename = $row['filename'];

	$full_path = $torrentspath . $torrentfilename;

	$fd = fopen("$full_path", "rb");
	$stream = fread($fd, filesize("$full_path"));
	fclose($fd);

	global $seeds, $peers, $completeddl, $estbandwidth, $error;

	$array = BDecode($stream);

	$infovariable = $array["info"];
	$infohash = sha1(BEncode($infovariable));
	$announce = $array["announce"];
	$internalname = $infovariable['name'];
	$creationdate = date('r' , $array["creation date"]);
	$datenow = date("M j, Y");

	$urlannounce = strtolower($announce);
	if (substr($urlannounce, 0, 7) === "http://"){
		if ((substr_count($urlannounce, "/announce")) == 1){
			$scrape = str_replace('/announce', '/scrape', $urlannounce);
			$httpget = "?info_hash=";
			$binsha1 = pack("H*", $infohash);
			$binsha1s = addslashes($binsha1);
			$fullurl = "$scrape$httpget$binsha1";
			$httpurl = pathurlencode($fullurl);
			sapeerconnect($httpurl, $binsha1s, $torrentsize);
		}else{
			$error = "Bad Tracker URL for scraping (Maybe Trackerless Torrent).";
		}
	}else{
		$error = "Bad Tracker URL for scraping (Maybe Trackerless Torrent).";
	}

	$query1 = mysql_query("SELECT id FROM $dbtorrentstable WHERE filename='$torrentfilename'")
		or die ("Unable to Run Query");

	while ($row1 = mysql_fetch_assoc($query1)){
		$id = $row1['id'];
	}

	$lastupdate = date("l, M j, Y");

	$query2 = mysql_query("UPDATE $dbtorrentstable SET seeds='$seeds', peers='$peers', completeddl='$completeddl', estbandwidth='$estbandwidth', errors='$error', lastupdate='$lastupdate' WHERE id='$id' LIMIT 1")
		or die ("Unable to Run Query");

	$seeds = "";
	$peers = "";
	$completeddl = "";
	$estbandwidth = "";
	$error = "";

}

mysql_close($database);

?>